package cn.wzpmc.hny.commands.hny;

import cn.wzpmc.hny.commands.hny.arguments.CustomItemArgumentType;
import cn.wzpmc.hny.commands.hny.sub.BuyCommand;
import cn.wzpmc.hny.commands.hny.sub.armor.ArmorUpgrade;
import cn.wzpmc.hny.games.PlayerDataManager;
import cn.wzpmc.hny.pojo.CustomItem;
import cn.wzpmc.hny.pojo.GlobalPlayerData;
import com.mojang.brigadier.Command;
import com.mojang.brigadier.builder.LiteralArgumentBuilder;
import com.mojang.brigadier.builder.RequiredArgumentBuilder;
import com.mojang.brigadier.context.CommandContext;
import com.mojang.brigadier.exceptions.CommandSyntaxException;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;
import org.mmga.utils.interfaces.MmgaCommand;

public class HnyCommand implements MmgaCommand, Command<CommandSender> {
    @Override
    public LiteralArgumentBuilder<CommandSender> getCommandBuilder() {
        return LiteralArgumentBuilder.<CommandSender>literal("hny")
                .requires(e -> e instanceof Player)
                .executes(this)
                .then(LiteralArgumentBuilder.<CommandSender>literal("armorUpgrade")
                        .then(LiteralArgumentBuilder.<CommandSender>literal("head-boost")
                                .executes(new ArmorUpgrade(true, false)))
                        .then(LiteralArgumentBuilder.<CommandSender>literal("legging-chest-plate")
                                .executes(new ArmorUpgrade(false, false)))
                        .then(LiteralArgumentBuilder.<CommandSender>literal("shield")
                                .executes(new ArmorUpgrade(false, true)))
                ).then(LiteralArgumentBuilder.<CommandSender>literal("buy")
                        .then(RequiredArgumentBuilder.<CommandSender, CustomItem>argument("item", new CustomItemArgumentType())
                                .executes(new BuyCommand()))
                );
    }

    @Override
    public int run(CommandContext<CommandSender> commandContext) throws CommandSyntaxException {
        Player player = (Player) commandContext.getSource();
        PlayerDataManager.getInstance().showPlayerData(player);
        return 0;
    }
}
